﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

using System.Drawing;

namespace GradientionSample
{
    public class GradientionButton : Control
    {
        private void DrawButton(Graphics g, bool pressed, bool focused)
        {
            // ボタンの背景を描画
            Pen backLinePen;
            backLinePen = new Pen(Color.Black);

            // DrawRectangleメソッドで線を描画するが
            // 線の太さを考慮して幅と高さから引く
            Rectangle lineRect = new Rectangle();
            lineRect.X = ClientRectangle.X;
            lineRect.Y = ClientRectangle.Y;
            lineRect.Width = ClientRectangle.Width - (int)backLinePen.Width;
            lineRect.Height = ClientRectangle.Height - (int)backLinePen.Width;

            g.FillRectangle(new SolidBrush(Color.DimGray), ClientRectangle);
            g.DrawRectangle(backLinePen, lineRect);

            // ボタンの表示領域
            Rectangle btnRect = ClientRectangle;
            btnRect.X += 2;
            btnRect.Y += 2;
            btnRect.Width -= 4;
            btnRect.Height -= 4;

            Color stColor, edColor;
            stColor = Color.Red;
            edColor = Color.Black;

            // 角丸グラデーションボタンの描画
            GraphicsExtension.DrawGradientRoundRectButton(
                g, btnRect, stColor, edColor, Color.Black, FillDirection.TopToBottom);

            // ボタンに表示するテキストの表示(テキストは中央に表示)
            StringFormat sf = new StringFormat();
            sf.LineAlignment = StringAlignment.Center;
            sf.Alignment = StringAlignment.Center;
            g.DrawString(Text, Font, new SolidBrush(Color.White), btnRect, sf);
        }
        
        protected override void OnPaint(PaintEventArgs e)
        {
            // とりあえず決め打ち。
            bool pressed = false;
            bool focused = false;

            DrawButton(e.Graphics, pressed, focused);
        }

        protected override void OnPaintBackground(PaintEventArgs e)
        {
            //base.OnPaintBackground(e);
        }
    }
}
